﻿//Tweak this if you want moar/less Marijan Sicklic
MAX_POSTS = 4;
MAX_SENTENCES_PER_POST=10;
MAX_HERPS_AND_DERPS_PER_SENTENCE=5;

//If you want to limit Marijan to certain threads, you can add the thread id in this array, in the form of [id1,id2,id3].
//If you keep it empty Marijan will post in every thread.
allowedThreads=[];//allowedThreads=[10483];

//You can add more insults or wishes if you want to enhance your Marijan Sicklic experience.
insults=["murderer","exceptional individual","feminazi","rapist","rape ape","Guatamalan trucker"];
wishes=["die","read my blog","get raped","get your teeth bashed in","move abroad"];

document.body.onload = initialize();

//Look up whether Marijan Sicklic should post in the current thread
function isAllowed(id)
{
	if(!allowedThreads||allowedThreads.length<1){
		return true;
	}
	for(var i=0;i<allowedThreads.length;i++)
	{
		if(allowedThreads[i]==id)
		{
			return true;
		}
	}
	return false;
}

//Pick a random insult from the list
function getInsult()
{
	return insults[Math.floor(random()*insults.length)];
}

//Pick a random wish from the list
function getWish()
{
	return wishes[Math.floor(random()*wishes.length)];
}

//This function does not produce very good random numbers, but at least now every time you visit the same page
//the posts Marijan Sicklic posts stay the same
function random() {
    var x = Math.sin(seed++) * 10000;
    return x - Math.floor(x);
}

//Return either herp or derp. To get a capitilized Herp or Derp use getFirstHerpOrDerp()
function getHerpOrDerp()
{
return random()*2<1?"herp":"derp";
}
function getFirstHerpOrDerp()
{
return random()*2<1?"Herp":"Derp";
}

//Generate a random post interspersed with herps, derps, insults and wishes
function generateMessage()
{
	var message="";
	var numSentences = Math.floor(random()*MAX_SENTENCES_PER_POST)+1;
	for(var i=0;i<numSentences;i++)
	{
		var herpsandderps=1;
		var max=Math.floor(MAX_HERPS_AND_DERPS_PER_SENTENCE*random());
		message+=getFirstHerpOrDerp();
		while(herpsandderps<max)
		{
			var toAdd=random()*8;
			if(toAdd<1)
			{
				message+=" "+getInsult();
			}
			else if(toAdd<2)
			{
				message+=" "+getWish();
			}
			else
			{
				message+=" "+getHerpOrDerp();
				herpsandderps++;
			}
		}
		message+=(i+1)%5==0?".<br/>":". ";
	}
	return message;
}

//Marijan Sicklic also quotes random persons, and then tries to insult them.
function getQuote(post)
{
	var userToQuote=post.getElementsByClassName("username")[0].innerHTML;
	var messageNodes=post.getElementsByClassName("messageText")[0].childNodes;
	var messageText="";
	for(var i=0;i<messageNodes.length;i++)
	{
		if(messageNodes[i].nodeValue)
		{
			messageText+=messageNodes[i].nodeValue;
		}
		else
		{
			messageText+="<br/>";
		}
	}
	if(messageText==null||messageText.length<=1)
	{
		return "";
	}
	return '<div class="bbCodeBlock bbCodeQuote" data-author="'+userToQuote+'">'+
'<aside><div class="attribution type">'+userToQuote+' said:'+
'<a href="goto/post?id=1153162#post-1153162" class="AttributionLink">\u2191</a>'+
'</div><blockquote class="quoteContainer"><div class="quote">'+messageText+'</div>'+
'<div class="quoteExpand quoteCut">Click to expand...</div></blockquote>'+
"</aside></div><br/>You are a "+getInsult()+". I hope you "+getWish()+". ";
}

function initialize() {
    var messageList = document.getElementById("messageList");
    if (messageList)
    {
        var currentThread = window.location.href;
        var lastSlashIndex= currentThread.lastIndexOf("/");
        var threadID = currentThread.substring(currentThread.lastIndexOf(".") + 1, lastSlashIndex);
	if(!isAllowed(threadID))
	{
		return;
	}
        var endOfPageIndex = currentThread.indexOf("#",lastSlashIndex);
        if (endOfPageIndex < 0)
        {
            endOfPageIndex = currentThread.length;
        }
        var pageNum = lastSlashIndex == currentThread.length - 1 ? 1 : currentThread.substring(currentThread.indexOf("-", lastSlashIndex) + 1, endOfPageIndex);
	//This sets the seed of the pseudoRNG, making sure that on the same page Marijan will always post the same posts.
        seed = threadID * pageNum;
        var numOfPostsToInsert = Math.floor(random() * (MAX_POSTS + 1));
        for (i = 0; i < numOfPostsToInsert; i++) {
            var posts = messageList.children;
            var numMessages = posts.length;
            var messageText = generateMessage();
            var postPos = Math.floor(random() * (posts.length - 1) + 1);
	    //every 4 posts he should quote the previous post
	    if(random()*4<1)
	    {
		messageText=getQuote(posts[postPos-1])+messageText;
            }
            var powerLevel = Math.floor(random() * 9)+1;
            var dumb = Math.floor(random() * 9)+1;
            var deviant = Math.floor(random() * 9)+1;
            var autistic = Math.floor(random() * 9)+1;
            var newItem = document.createElement("LI");
            newItem.setAttribute("id", "post-1157276");
            newItem.setAttribute("class", "sectionMain message ");
            newItem.setAttribute("data-author", "Marjan Siklic");
            var dateTimeElement=posts[postPos-1].getElementsByClassName("DateTime")[0];
            var dateTime=dateTimeElement.getAttribute("title");
	    var indexToSplit=dateTime.indexOf(" at ");
	    var date=dateTime.substring(0,indexToSplit);
	    var time=dateTime.substring(indexToSplit+4);
            var dateString=dateTimeElement.innerHTML;
	    //Copied this HTML from a real post, take it as a basis.
            var samplePost = '<div class="uix_message ">'+
                    '<div class="messageUserInfo" itemscope="itemscope" itemtype="http://data-vocabulary.org/Person">'
                    +'<div class="messageUserBlock ">'+
                    '<div class="avatarHolder">'+
                    '<div class="uix_avatarHolderInner">'+
                    '<span class="helper"></span>'+
                    '<a href="members/marjan-%C5%A0ikli%C4%87.4670/" class="avatar Av4670l" data-avatarhtml="true">'+
                    '<img src="https://kfcdn.xyz/data/avatars/l/4/4670.jpg?1422527665" width="192" height="192" alt="Marjan Šiklic">'+
                    '</a> <!-- slot: message_user_info_avatar --> </div> </div>'+
                    '<h3 class="userText"> <div class="uix_userTextInner">'+
                    '<a href="members/marjan-%C5%A0ikli%C4%87.4670/" class="username" dir="auto" itemprop="name">Marjan Šiklic</a>'+
                    '<em class="userTitle" itemprop="title">Cunt Destroyer</em> </div>'+
                    '<em class="userBanner bannerSkyBlue wrapped" itemprop="title">'+
                    '<span class="before"></span><strong>Verified</strong><span class="after"></span></em>'+
                    '<!-- slot: message_user_info_text --> </h3> <span class="arrow"><span></span></span> </div>'+
                    '</div> <div class="messageInfo primaryContent"> <div class="messageContent"> <article>'+
                    '<blockquote class="messageText SelectQuoteContainer ugc baseHtml">' + messageText +
                    '<div class="messageTextEndMarker">&nbsp;</div> </blockquote> </article> </div>'+
                    '<div class="messageDetails">'+
                    '<a title="Permalink" class="item muted postNumber hashPermalink OverlayTrigger" data-href="posts/1157276/permalink">#1</a>'+
                    '<span class="item muted"> <span class="authorEnd">'+
                    '<a href="members/marjan-%C5%A0ikli%C4%87.4670/" class="username author" dir="auto">Marjan Šiklic</a>'+
                    ',</span> <a href="threads/all-guatemalans-are-rapists.15519/" title="Permalink" class="datePermalink">'+
                    '<abbr class="DateTime" data-time="1450495888" data-diff="40667" data-datestring="'+date+'" data-timestring="'+time+'" title="' + dateTime +
                    '">' + dateString + '</abbr></a> </span> </div>'+
		     '<div class="messageMeta ToggleTriggerAnchor">'+
		     '<div class="privateControls">'+
		   '<a href="posts/1153452/report" class="OverlayTrigger item control report" data-cacheoverlay="false">'+
		     '<span></span>Report</a> </div> <div class="publicControls">'+
		     '<div class="Popup PopupControl PopupClosed uix_postbit_privateControlsMenu PopupContainerControl">'+
                     '<a rel="Menu" class="NoPopupGadget"><i class="uix_icon"></i>Tools</a> </div>'+
                     '<a href="#" data-messageid="" class="MultiQuoteControl JsOnly item control" title="Toggle Multi-Quote">'+
		     '<span></span><span class="symbol">+ Quote</span></a>'+
		     '<a href="#" data-posturl="" class="ReplyQuote item control reply" title="Reply, quoting this message"><span>'+
                    '</span>QUOTE ME NOW</a> </div> </div>'+
                    '<div class="dark_postrating likesSummary secondaryContent">'+
                    '<div class="dark_postrating_container">'+
                    '<ul class="dark_postrating_outputlist" style="opacity: 0.1;">'+
                    '<li> <img src="styles/dark/ratings/powerlevel.png" alt="Powerlevel" title="Powerlevel">'+
                    'Powerlevel x <strong>' + powerLevel + '</strong> </li>'+
                    '<li> <img src="styles/dark/ratings/bin_empty.png" alt="Dumb" title="Dumb">'+
                    'Dumb x <strong>' + dumb + '</strong> </li> <li>'+
                    '<img src="styles/default/xenforo/clear.png" alt="Deviant" title="Deviant" style="background: url(\'styles/dark/ratings/rating_luna_charity.png\') no-repeat -16px -16px; width: 16px; height: 16px;">'+
                    'Deviant x <strong>' + deviant + '</strong> </li> <li>'+
                    '<img src="styles/dark/ratings/autistic.png" alt="Autistic" title="Autistic">'+
                    'Autistic x <strong>' + autistic + '</strong> </li></ul>'+
                    '<script type="text/javascript"> var dark_postrating_minimum_opacity = 0.1; </script>'+
                    '<ul class="dark_postrating_inputlist " style="opacity: 0.1;"> <li>'+
                    '<a data-rate-id="1" href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/default/xenforo/clear.png" alt="Like" style="background: url(\'styles/dark/ratings/spritesheet.png\') no-repeat 0px -32px; width: 16px; height: 16px;"></a>'+
                    '</li> <li><a data-rate-id="14" href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/default/xenforo/clear.png" alt="Dislike" style="background: url(\'styles/dark/ratings/spritesheet.png\') no-repeat 0px -208px; width: 16px; height: 16px;"></a>'+
                    '</li> <li><a data-rate-id="2" href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/default/xenforo/clear.png" alt="Agree" style="background: url(\'styles/dark/ratings/spritesheet.png\') no-repeat 0px -16px; width: 16px; height: 16px;"></a>'+
                    '</li> <li><a data-rate-id="3" href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/default/xenforo/clear.png" alt="Disagree" style="background: url(\'styles/dark/ratings/spritesheet.png\') no-repeat 0px -144px; width: 16px; height: 16px;"></a>'+
                    '</li> <li><a data-rate-id="5" href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/default/xenforo/clear.png" alt="Winner" style="background: url(\'styles/dark/ratings/spritesheet.png\') no-repeat 0px -192px; width: 16px; height: 16px;"></a></li>'+
                    '<li><a data-rate-id="6" href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/default/xenforo/clear.png" alt="Informative" style="background: url(\'styles/dark/ratings/spritesheet.png\') no-repeat 0px -96px; width: 16px; height: 16px;"></a></li>'+
                    '<li><a data-rate-id="7"  href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/default/xenforo/clear.png" alt="Feels" style="background: url(\'styles/dark/ratings/spritesheet.png\') no-repeat 0px -112px; width: 16px; height: 16px;"></a>'+
                    '</li> <li><a data-rate-id="30"  href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/dark/ratings/islamic.png" alt="Islamic Content"></a></li>'+
                    '<li><a data-rate-id="13"  href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/dark/ratings/autistic.png" alt="Autistic"></a></li>'+
                    '<li><a data-rate-id="9"  href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/default/xenforo/clear.png" alt="Optimistic" style="background: url(\'styles/dark/ratings/spritesheet.png\') no-repeat 0px -64px; width: 16px; height: 16px;"></a></li>'+
                    '<li><a data-rate-id="29"  href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/dark/ratings/powerlevel.png" alt="Powerlevel"></a></li>'+
                    '<li><a data-rate-id="21"  href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/dark/ratings/link_break.png" alt="Off-Topic"></a></li>'+
                    '<li><a data-rate-id="11"  href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/default/xenforo/clear.png" alt="Late" style="background: url(\'styles/dark/ratings/spritesheet.png\') no-repeat 0px -160px; width: 16px; height: 16px;"></a></li>'+
                    '<li><a data-rate-id="17"  href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/dark/ratings/bin_empty.png" alt="Dumb"></a></li>'+
                    '<li><a data-rate-id="16"  href="#" class="Tooltip" data-offsety="-13" data-offsetx="-8">'+
                    '<img src="styles/dark/ratings/alog.png" alt="A-Log"></a></li> </ul> </div>'+
                    '<div style="clear: right;"></div> </div> </div> </div>';
            newItem.innerHTML = samplePost;
            messageList.insertBefore(newItem, posts[postPos]);
        }
    }
}